﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Input;

namespace DiffernetXamContextMenuBasesOnClickedItem
{
    public class MainViewModel : PropertyChangedNotifier
    {
        private ObservableCollection<ParentViewModel> gridData;

        private ICommand _childCommand = null;
        private ICommand _parentCommand = null;
        private ICommand _rootCommand = null;

        public MainViewModel()
        {
            _childCommand = new RelayCommand<ChildViewModel>(ChildMethod);
            _parentCommand = new RelayCommand<ParentViewModel>(ParentMethod);
            _rootCommand = new RelayCommand(RootMethod);

            GridData = new ObservableCollection<ParentViewModel>();
            for (int i = 0; i < 10; i++)
            {
                ParentViewModel pvm = new ParentViewModel
                {
                    ID = i,
                    Name = "Parent " + i,
                    Email = "parent" + i + "@infragistics.com",
                    Children = new ObservableCollection<ChildViewModel>()
                };

                for (int j = 0; j < 5; j++)
                {
                    pvm.Children.Add(new ChildViewModel
                    {
                        ChildID = j,
                        Name = "Child " + j,
                        Age = 10 + i + j
                    });
                }

                GridData.Add(pvm);
            }
        }

        public ICommand ChildCommand
        {
            get { return _childCommand; }
        }

        public ICommand ParentCommand
        {
            get { return _parentCommand; }
        }

        public ICommand RootCommand
        {
            get { return _rootCommand; }
        }

        private void ChildMethod(ChildViewModel child)
        {
            MessageBox.Show(child == null ? "child is NULL" : child.Name);
        }

        private void ParentMethod(ParentViewModel parent)
        {
            MessageBox.Show(parent == null ? "parent is NULL" : parent.Name);
        }

        private void RootMethod()
        {
            MessageBox.Show("Empty Area Menu");
        }

        public ObservableCollection<ParentViewModel> GridData
        {
            get { return gridData; }
            set { gridData = value; OnPropertyChagned("GridData"); }
        }
    }
}
